<template>
    <div class="column justify-center items-center q-gutter-y-md q-pa-md">
        <div class="text-h5 text-weight-light">Delete SubContractor</div>
        <div class="text-body1">
            Are you sure you want to delete
            <span class="text-primary"> {{ subcontractor.name }} </span>
            with ID
            <span class="text-primary"> {{ subcontractor.id }}? </span> <br>
            This action cannot be undone
        </div>


        <div class="text-body1">
            Please enter the Subcontractor name
            <code class="text-negative bg-red-1">
                {{ subcontractor.name }}</code>
            to complete the delete process.
        </div>
        <div class="full-width">
            <q-input filled ref='name' @input='OnType' label="SubContractor Name" v-model="subcontractorName"
                     :rules="[(s) => s === subcontractor.name || 'Please enter the subcontractor name']" class="full-width"/>
        </div>
        <div class="row justify-between full-width">
            <q-btn outline @click="$emit('back')">
                Back
            </q-btn>
            <q-btn @click="Delete" :disable="!valid" icon="delete" label="delete" color="negative">
            </q-btn>
        </div>


    </div>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {SubContractorPrincipalResponse} from "src/classLibrary/APIModels/core/subContractorPrincipalResponse";


@Component
export default class DeleteProjectDialog extends Vue {
    @Prop() subcontractor!: SubContractorPrincipalResponse;

    subcontractorName: string = '';


    valid = false;

    OnType() {
        const n = this.$refs.name as any;
        n.validate()
        this.valid = n.hasError;
    }

    async Delete() {
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.QDelete(`SubContractor/${this.subcontractor.id}`, null, token);
        r.match({
            some: (s) => {
                this.$q.notify({
                    color: 'negative',
                    message: `Failed to delete subcontractor ${this.subcontractor.name}`,
                    icon: 'danger'
                });
                console.info(s);
            },
            none: () => {
                this.$q.notify({
                    color: 'positive',
                    message: `Successfully deleted subcontractor ${this.subcontractor.name}`,
                    icon: 'check'
                });
                this.$emit('deleted', this.subcontractor);
            }
        })
    }

}
</script>
